<script setup>

import { useRouter, useRoute } from 'vue-router';
import * as pathToRegexp from 'path-to-regexp'
import { ref, watch } from 'vue';

const router = useRouter()
const route = useRoute()

const levelList = ref()
function getBreadcrumb() {
  const matched = route.matched.filter(item => item?.meta?.title)
  // const first = matched[0]
  // if (!isDashboard(first)) {
  //   matched = [{ path: '/', meta: { title: '首页' } }].concat(matched)
  // }
  levelList.value = matched.filter(item => item.meta.breadcrumb !== false)
}

watch(
  () => route.path,
  () => {
    getBreadcrumb()
  },
  {
    immediate: true
  })


function pathCompile(path) {
  // To solve this problem https://github.com/PanJiaChen/vue-element-admin/issues/561
  const { params } = route
  const toPath = pathToRegexp.compile(path)
  return toPath(params)
}
function handleLink(item) {
  const { redirect, path } = item
  if (redirect) {
    router.push(redirect)
    return
  }
  router.push(pathCompile(path))
}
</script>

<template>
  <el-breadcrumb class="app-breadcrumb" separator="/">
    <transition-group name="breadcrumb">
      <el-breadcrumb-item v-for="(item, index) in levelList" :key="item.path">
        <span v-if="item.redirect === false || index === levelList.length - 1" class="no-redirect">{{
            item.meta.title
        }}</span>
        <a v-else @click.prevent="handleLink(item)">{{ item.meta.title }}</a>
      </el-breadcrumb-item>
    </transition-group>
  </el-breadcrumb>
</template>


<style lang="scss" scoped>
// .app-breadcrumb.el-breadcrumb {
//   display: inline-block;
//   font-size: 14px;
//   margin-left: 8px;

//   .no-redirect {
//     color: #97a8be;
//     cursor: text;
//   }
// }

/* breadcrumb transition */
.breadcrumb-enter-active,
.breadcrumb-leave-active {
  transition: all .5s;
}

.breadcrumb-enter,
.breadcrumb-leave-active {
  opacity: 0;
  transform: translateX(20px);
}

.breadcrumb-move {
  transition: all .5s;
}

.breadcrumb-leave-active {
  position: absolute;
}
</style>
